@echo off
cls
if not exist local.mix if not exist cclocal.mix goto mix_error
if not exist starwars.mix goto file_error
if not exist mmlite.exe goto file_error
:options
cls
if not exist replb.com mmlite starwars.mix -e reply.com replb.com >nul
if not exist replb.com goto write_error
if exist scswmain.mix echo "C&C meets Star Wars" setup Program:                            [Mod installed]
if not exist scswmain.mix echo "C&C meets Star Wars" setup Program:
echo =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
echo.
echo   F1 : View Star Wars units info
echo   F2 : View Star Wars buildings info
echo   F3 : View Star Wars superweapons info
echo.
if exist scswmain.mix     echo   F4 : Reinstall Star Wars mod
if not exist scswmain.mix echo   F4 : Install Star Wars mod
echo   F5 : Uninstall Star Wars mod
echo.
echo.
echo [ESC]: Quit
echo.
echo Which would you like to do?
:reply
replb
if errorlevel 59 if not errorlevel 60 goto info1
if errorlevel 60 if not errorlevel 61 goto info2
if errorlevel 61 if not errorlevel 62 goto info3
if errorlevel 62 if not errorlevel 63 goto install
if errorlevel 63 if not errorlevel 64 goto uninstall
if errorlevel 27 if not errorlevel 28 goto end
goto reply

:info1
cls
::   12345678901234567890123456789012345678901234567890123456789012345678901234567890
echo.                                  --==UNITS==--
echo -------------------------------------------------------------------------------
echo Name:                                  Replaces:
echo -------------------------------------------------------------------------------
echo Trooper                                Minigunner
echo Laser Trooper                          Bazooka Soldier
echo Mercenary                              Commando
echo Speeder Bike                           Recon Bike
echo X-34 landspeeder                       Nod buggy
echo Jawa Sandcrawler                       Harvester
echo TIE Crawler                            Hum-vee
echo T-47 Airspeeder                        Light Tank
echo AT-ST (All Terrain Scout Transport)    Medium Tank
echo AT-AT (All Terrain Armoured Transport) Mammoth Tank
echo A-Wing                                 Apache Attack Helicopter
echo Lambda Class Shuttle                   Chinook Transport Helicopter
echo TIE Fighter                            Orca
echo TIE Bomber                             A-10 Support Airplane
echo Rebel Transport Vessel                 C17 Transport Plane
echo -------------------------------------------------------------------------------
echo.
pause
goto options

:info2
cls
echo.                               --==STRUCTURES==--
echo -------------------------------------------------------------------------------
echo Name:                                  Replaces:
echo -------------------------------------------------------------------------------
echo Millennium Falcon                      Hand of Nod
echo Shield Generator                       Power Plant
echo Advanced Shield Generator              Advanced Power Plant
echo Laser Turret                           Gun Turret
echo Jawa Scrap Refinery                    Tiberium Refinery
echo Command Center                         Communications Center
echo Shield Projector                       Advanced Communications Center
echo Heavy Ion Cannon                       Temple of Nod
echo Spaceport                              Airstrip
echo Anti-Air Laser (*)                     SAM Site
echo Scrap Silo                             Tiberium Silo
echo Launch Platform                        Helicopter pad
echo Super Shield Generator                 Tech Center
echo -------------------------------------------------------------------------------
echo (*) : Only the names change; no new graphics except CNC95 icon
echo.
pause
goto options

:info3
cls
echo.                              --==SUPERWEAPONS==--
echo -------------------------------------------------------------------------------
echo Name:                                  Replaces:
echo -------------------------------------------------------------------------------
echo Death Star                             Ion Cannon
echo Ion Cannon                             Nuclear Weapon
echo Tie Airstrike                          Airstrike
echo -------------------------------------------------------------------------------
echo.
pause
goto options


:install
cls
echo Installing, Please Stand By...
echo.
echo.
echo Installing Snow theater...
if exist wintr1st.mix goto oversnow
if exist wintr1st.dat goto oversnow
if not exist winter.mix echo Check file to correctly uninstall snow theater - do not remove! > wintr1st.dat
if exist winter.mix if not exist wintr1st.mix echo Original Winter theater backup file: "WINTR1ST.MIX"
if exist winter.mix if not exist wintr1st.mix echo This file will be restored when you uninstall the mod.
if exist winter.mix if not exist wintr1st.mix move winter.mix wintr1st.mix >nul

:oversnow
if exist winter.mix del winter.mix >nul
mmlite starwars.mix -e winter.mix >nul
echo Done
echo.
echo Installing Star Wars Sounds and Graphics...
if not exist swbackup.mix mmlite swbackup.mix -n >nul
mmlite starwars.mix -e scswmain.mix >nul
mmlite starwars.mix -e scswsnd.mix >nul

if exist "C&C95.exe" goto winstall
goto winend
:winstall
mmlite starwars.mix -e scswicnh.mix >nul
mmlite updatec.mix -e hradar.gdi gdiradar.shp >nul
mmlite updatec.mix -e hradar.nod nodradar.shp >nul
mmlite swbackup.mix -a hradar.gdi gdiradar.shp >nul
mmlite swbackup.mix -a hradar.nod nodradar.shp >nul
mmlite swbackup.mix -d expand.dat >nul
mmlite starwars.mix -e hradar.gdi gdiradar.shp >nul
mmlite starwars.mix -e hradar.nod nodradar.shp >nul
mmlite updatec.mix -r hradar.gdi gdiradar.shp >nul
mmlite updatec.mix -r hradar.nod nodradar.shp >nul
del gdiradar.shp >nul
del nodradar.shp >nul
mmlite starwars.mix -e htitle.pcx >nul
:winend

mmlite starwars.mix -e scswmiss.mix >nul
mmlite starwars.mix -e atomdoor.shp >nul

if exist GAME.DAT if not exist GAME.NEW mmlite starwars.mix -e scswicon.mix >nul
if exist GAME.NEW mmlite starwars.mix -e scswicon.mix >nul
if exist GAME.DAT if not exist GAME.NEW mmlite starwars.mix -e title.cps >nul
if exist GAME.NEW mmlite starwars.mix -e title.cps >nul

echo Done
echo.
echo Installing Star Wars names...
if not exist ccnmxd.exe mmlite starwars.mix -e ccnames.exe ccnmxd.exe>nul
if not exist "C&C95.exe" mmlite local.mix -e conquer.eng >nul
if exist "C&C95.exe" mmlite cclocal.mix -e conquer.eng >nul
mmlite swbackup.mix -a conquer.eng >nul
mmlite swbackup.mix -e conquer.eng >nul
ccnmxd -r:86  "T-47 Airspeeder" >nul
ccnmxd -r:87  "AT-ST" >nul
ccnmxd -r:88  "AT-AT" >nul
ccnmxd -r:89  "X-34 Landspeeder" >nul
ccnmxd -r:90  "AA-Laser" >nul
ccnmxd -r:91  "Shield Projector" >nul
ccnmxd -r:94  "TIE Crawler" >nul
ccnmxd -r:95  "Lambda Class Shuttle" >nul
ccnmxd -r:96  "TIE Bomber" >nul
ccnmxd -r:98  "Jawa Sandcrawler" >nul
ccnmxd -r:101 "Trooper" >nul
ccnmxd -r:103 "Laser trooper" >nul
ccnmxd -r:106 "Mercenary" >nul
ccnmxd -r:108 "A-wing" >nul
ccnmxd -r:109 "TIE fighter" >nul
ccnmxd -r:111 "Laser Post" >nul
ccnmxd -r:112 "Command Center" >nul
ccnmxd -r:113 "Launch Platform" >nul
ccnmxd -r:114 "Spaceport" >nul
ccnmxd -r:115 "Scrap Silo" >nul
ccnmxd -r:117 "Jawa Scrap Refinery" >nul
:: ccnmxd -r:139 "Door" >nul
:: ccnmxd -r:146 "Door" >nul
ccnmxd -r:154 "Super Shield Generator" >nul
ccnmxd -r:155 "Turbolaser" >nul
ccnmxd -r:158 "Speeder Bike" >nul
ccnmxd -r:159 "Shield Generator" >nul
ccnmxd -r:160 "Adv. Shield Generator" >nul
ccnmxd -r:162 "Imperial Barracks" >nul
ccnmxd -r:172 "Plasma Battery" >nul
ccnmxd -r:175 "Millennium Falcon" >nul
ccnmxd -r:176 "Heavy Ion Cannon" >nul
ccnmxd -r:227 "Princess Leia" >nul
ccnmxd -r:231 "Death Star" >nul
ccnmxd -r:232 "Ion Cannon" >nul
ccnmxd -r:586 "IMP:">nul
ccnmxd -r:594 "REB:">nul
if exist ccnmxd.exe del ccnmxd.exe >nul

if exist "c&c95.exe" mmlite cclocal.mix -r conquer.eng >nul
if not exist "c&c95.exe" mmlite local.mix -r conquer.eng >nul
del conquer.eng >nul

echo Done
echo.
echo.
echo Installation Complete.
pause
goto options

:uninstall
cls
echo Uninstalling, Please Stand By...
echo.
set ccswinst=
if exist scswmain.mix set ccswinst=true
if "%ccswinst%" == "true" if not exist swbackup.mix echo WARNING: File "SWBACKUP.MIX" not found!
if "%ccswinst%" == "true" if not exist swbackup.mix echo Cannot recover backups of original Command and Conquer files.
if "%ccswinst%" == "true" if not exist swbackup.mix echo To fully uninstall the mod, you will have to reinstall Command and Conquer.
if "%ccswinst%" == "true" if not exist swbackup.mix echo.

if not exist winter.mix goto keepsnow
if not exist wintr1st.dat if not exist wintr1st.mix goto keepsnow


echo.
echo Uninstall Snow theater? [Y,N]
:unsnow
replb
if errorlevel 121 if not errorlevel 122 goto delsnow
if errorlevel 110 if not errorlevel 111 goto keepsnow
goto unsnow
:delsnow
echo Uninstalling Snow theater...
del winter.mix >nul
if exist wintr1st.mix move wintr1st.mix winter.mix >nul
if exist wintr1st.dat del wintr1st.dat >nul
echo Done
:keepsnow
echo.
echo Uninstalling Star Wars Sounds and Graphics...
if exist scswmain.mix del scswmain.mix >nul
if exist scswsnd.mix  del scswsnd.mix  >nul
if exist scswicon.mix del scswicon.mix >nul
if exist scswicnh.mix del scswicnh.mix >nul
if exist scswmiss.mix del scswmiss.mix >nul
if exist atomdoor.shp del atomdoor.shp >nul
if exist GAME.DAT if exist title.cps del title.cps >nul
if exist GAME.NEW if exist title.cps del title.cps >nul

if exist "C&C95.exe" goto wunstall
goto wunend
:wunstall

if "%ccswinst%" == "true" if not exist swbackup.mix echo File "SWBACKUP.MIX" not found - Cannot recover original radar logos.
if exist gdiradar.shp del gdiradar.shp >nul
if exist nodradar.shp del nodradar.shp >nul
mmlite swbackup.mix -e hradar.gdi gdiradar.shp >nul
mmlite swbackup.mix -e hradar.nod nodradar.shp >nul
mmlite updatec.mix -r hradar.gdi gdiradar.shp >nul
mmlite updatec.mix -r hradar.nod nodradar.shp >nul
if exist gdiradar.shp del gdiradar.shp >nul
if exist nodradar.shp del nodradar.shp >nul
if exist htitle.pcx del htitle.pcx >nul
:wunend

echo Done

echo.
echo Uninstalling Star Wars names...
if "%ccswinst%" == "true" if not exist swbackup.mix echo File "SWBACKUP.MIX" not found - Cannot recover original game strings.
if exist conquer.eng del conquer.eng >nul
mmlite swbackup.mix -e conquer.eng >nul
if exist "c&c95.exe" mmlite cclocal.mix -r conquer.eng >nul
if not exist "c&c95.exe" mmlite local.mix -r conquer.eng >nul
if exist conquer.eng del conquer.eng >nul
set ccswinst= 
echo Done
echo.
echo.
echo Uninstall Complete.

if exist swbackup.mix del swbackup.mix >nul

pause
goto options


:mix_error
echo LOCAL.MIX / CCLOCAL.MIX not found!
echo Make sure you run this program in your CNC directory.
echo.
pause
goto end

:write_error
echo Error writing file.
echo If you are using Vista, make sure you have ownership of the directory.
echo.
pause
goto end


:file_error
echo One of the most essential files is missing. Make sure you have:
echo.
echo mmlite.exe
echo starwars.mix
echo.
pause

:end
if exist replb.com del replb.com >nul
if exist ccnmxd.exe del ccnmxd.exe >nul